
; todo :



#include "sng10.inc"

DefaultXSpriteHeight = 8

tilemap_length = 16

x_coord     =     TEXT_MEM
y_coord     =     TEXT_MEM + 1

 .ORG START_ADDR
 
start:
 
 .db "tilemap engine",0
 
 
 
      ROM_CALL(CLEARLCD)
      
      
      xor   a
      ld    (x_coord),a   ; start drawing at (0,0)
      ld    (y_coord),a
      
      
loop:
      ld    hl,GRAPH_MEM
      ld    de,GRAPH_MEM + 1
      ld    (hl),0
      ld    bc,767
      ldir

      ld    hl,tilemap
      ld    de,tiles
      ld    a,(x_coord)
      ld    b,a
      ld    a,(y_coord)
      ld    c,a
      call  disp_tilemap
      call  GRB_COPY
wfk:
      ld    a,$fd       ; [CLEAR]
      out   (1),a
      in    a,(1)
      bit   6,a
      ret   z
      
      ld    a,$fe       ; keys
      out   (1),a
      in    a,(1)
      ld    b,a
      bit   1,b
      call  z,_left
      bit   2,b
      call  z,_right
      bit   3,b
      call  z,_up
      bit   0,b
      call  z,_down
      ld    b,a
      or    a
      jr    z,wfk
      jr    loop
      
_up:
      ld    hl,y_coord
      ld    a,(hl)
      or    a
      ret   z
      dec   (hl)
      ret
_down:
      ld    hl,y_coord
      ld    a,(hl)
      cp    32*8-64-1
      ret   z
      inc   (hl)
      ret
_right:
      ld    hl,x_coord
      ld    a,(hl)
      cp    32*8-96-1
      ret   z
      inc   (hl)
      ret
_left:
      ld    hl,x_coord
      ld    a,(hl)
      or    a
      ret   z
      dec   (hl)
      ret
      
      
      
tilemap_start:
      
; tilemap routine - pacHa '04-'05
; map of 32x32 sprites of 8x8 pixels (256x256)
; input :
; hl -> tilemap
; de -> tiles
; b,c : start coords
;
; 117 bytes


disp_tilemap:
      push  de          ; on sauve l'adresse de debut des tiles

      ld    a,c               ; traitement de la coordonne y
      and   %11111000
      ;srl   a    ; faudrait faire /8, mais on va faire x32 plus tard...
      ;srl   a
      ;srl   a                 ; a contient le No de la ligne ou se situe la tile
      ld    e,a
      ld    d,0
      
      ;sla e \ rl d      ; de x 32 -> ligne de la tile (x4 en fait, car on a pas fait /8 avant)
      ;sla e \ rl d
      ;sla e \ rl d
      sla e \ rl d
      sla e \ rl d
      
      add   hl,de             ; hl -> ligne de la tile
      
      ld    a,b               ; traitement de x
      and   %11111000
      srl   a
      srl   a
      srl   a                 ; a contient le No de la colonne ou est la tile
      ld    d,0
      ld    e,a
      add   hl,de             ; hl -> 1ere tile
      
      ld    a,b
      and   %00000111
      cpl
      ld    b,a               ; on met  jour la coord x (dcalage)
      ld    (dec_x),a         ; on le sauve, on en aura besoin  chaque nouvelle ligne
      ld    a,c
      and   %00000111
      cpl
      ld    c,a               ; idem pour y
      
      pop   de                ; on ressort l'adresse de debut des tiles

next_tile:      
      push  bc                ; on sauve les coords o afficher les sprites des tiles
      push  hl                ; et on sauve l'adresse de la tile courante
      
      ld    a,(hl)            ; on prend le type de tile  afficher
      or    a                 ; = cp 0
      jr    z,empty_tile      ; si c'est 0, on affiche rien
      dec   a                 ; le 1 pointe donc sur le 1er sprite des tiles : 0 de dcalage
      add   a,a
      add   a,a
      add   a,a               ; x8, pour pointer sur le bon sprite
      
      ex    de,hl             ; hl -> debut des tiles
      ld    d,0
      ld    e,a
      add   hl,de             ; hl -> tile  afficher
      
      call  PutSprClpXOR      ; affichage du sprite, avec clip
      
empty_tile:
      pop   hl                ; on ressort les coords de la tile courante
      inc   hl                ; on passe  la suivante
      pop   bc                ; on ressort les coords des tiles sur l'cran
      ld    a,b
      add   a,8
      cp    96
      jr    c,nonextline
      ld    de,19             ; hl -> ligne suivante dans la tilemap
      add   hl,de             ; on ajoute 19 car on a dja affich 13, et 32-13=19 =)
      ld    a,c               ; ligne suivante
      add   a,8               ; si on est...
      cp    64                ;             trop loin...
      ret   nc                ;                         c'est fini !
      ld    c,a
      ld    a,(dec_x)         ; decalage x initial
nonextline:
      ld    b,a               ; on passe  l'endroit suivant
      
      ld    de,tiles
      jp    next_tile
      
      
      ret
      
      
dec_x:
      .db   0
 
tilemap_end:
      
 
.include    data_tiles.inc
.include    data_tilemap.inc
      
      
.include    spr21x.inc

end:

.echo "\nTaille du prog : "
.echo end-start
.echo "\n\nTaille de la routine de tilemap : "
.echo tilemap_end-tilemap_start
.echo "\n\n"


 